<html>
<head>
<title>OgreSceneManagerEnumerator.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreSceneManagerEnumerator.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreSceneManagerEnumerator_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __SceneManagerEnumerator_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __SceneManagerEnumerator_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreSceneManager_8h.html">OgreSceneManager.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038     
<a name="l00045"></a>00045 
<a name="l00046"></a><a class="code" href="classOgre_1_1DefaultSceneManagerFactory.html">00046</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1DefaultSceneManagerFactory.html" title="Factory for default scene manager.">DefaultSceneManagerFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SceneManagerFactory.html" title="Class which will create instances of a given SceneManager.">SceneManagerFactory</a>
<a name="l00047"></a>00047     {
<a name="l00048"></a>00048     <span class="keyword">protected</span>:
<a name="l00049"></a>00049         <span class="keywordtype">void</span> initMetaData(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00050"></a>00050     <span class="keyword">public</span>:
<a name="l00051"></a><a class="code" href="classOgre_1_1DefaultSceneManagerFactory.html#affd69f67c70d61231b323b1de67af92f">00051</a>         <a class="code" href="classOgre_1_1DefaultSceneManagerFactory.html#affd69f67c70d61231b323b1de67af92f">DefaultSceneManagerFactory</a>() {}
<a name="l00052"></a><a class="code" href="classOgre_1_1DefaultSceneManagerFactory.html#a87932aa032f993f51292da737f5e83f3">00052</a>         <a class="code" href="classOgre_1_1DefaultSceneManagerFactory.html#a87932aa032f993f51292da737f5e83f3">~DefaultSceneManagerFactory</a>() {}
<a name="l00054"></a><a class="code" href="classOgre_1_1DefaultSceneManagerFactory.html#aecb930d0603388f00979d9822a24d7bf">00054</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1DefaultSceneManagerFactory.html#aecb930d0603388f00979d9822a24d7bf" title="Factory type name.">FACTORY_TYPE_NAME</a>;
<a name="l00055"></a>00055         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* createInstance(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName);
<a name="l00056"></a>00056         <span class="keywordtype">void</span> destroyInstance(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* instance);
<a name="l00057"></a>00057     };
<a name="l00059"></a><a class="code" href="classOgre_1_1DefaultSceneManager.html">00059</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1DefaultSceneManager.html" title="Default scene manager.">DefaultSceneManager</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>
<a name="l00060"></a>00060     {
<a name="l00061"></a>00061     <span class="keyword">public</span>:
<a name="l00062"></a>00062         <a class="code" href="classOgre_1_1DefaultSceneManager.html" title="Default scene manager.">DefaultSceneManager</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00063"></a>00063         ~<a class="code" href="classOgre_1_1DefaultSceneManager.html" title="Default scene manager.">DefaultSceneManager</a>();
<a name="l00064"></a>00064         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getTypeName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00065"></a>00065     };
<a name="l00066"></a>00066 
<a name="l00087"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html">00087</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1SceneManagerEnumerator.html" title="Enumerates the SceneManager classes available to applications.">SceneManagerEnumerator</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;SceneManagerEnumerator&gt;, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">SceneMgtAlloc</a>
<a name="l00088"></a>00088     {
<a name="l00089"></a>00089     <span class="keyword">public</span>:
<a name="l00091"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a65139ae5132fad9d21fae64c0b22ceb4">00091</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, SceneManager*&gt;::type</a> <a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a65139ae5132fad9d21fae64c0b22ceb4" title="Scene manager instances, indexed by instance name.">Instances</a>;
<a name="l00093"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a5fde27af1394a5e2229c624c556629c0">00093</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;const SceneManagerMetaData*&gt;::type</a> <a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a5fde27af1394a5e2229c624c556629c0" title="List of available scene manager types as meta data.">MetaDataList</a>;
<a name="l00094"></a>00094     <span class="keyword">private</span>:
<a name="l00096"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a548d5ed3effef1094bb9ca240ea4bf8d">00096</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;SceneManagerFactory*&gt;::type</a> <a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a548d5ed3effef1094bb9ca240ea4bf8d" title="Scene manager factories.">Factories</a>;
<a name="l00097"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#ab1a2d0123b64f95a29460d176b36d971">00097</a>         <a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a548d5ed3effef1094bb9ca240ea4bf8d" title="Scene manager factories.">Factories</a> <a class="code" href="classOgre_1_1SceneManagerEnumerator.html#ab1a2d0123b64f95a29460d176b36d971">mFactories</a>;
<a name="l00098"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a94dbb182944a32cf82137b253351d8ee">00098</a>         <a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a65139ae5132fad9d21fae64c0b22ceb4" title="Scene manager instances, indexed by instance name.">Instances</a> <a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a94dbb182944a32cf82137b253351d8ee">mInstances</a>;
<a name="l00100"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a966292fbcb304e584f411075f95cf5b2">00100</a>         <a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a5fde27af1394a5e2229c624c556629c0" title="List of available scene manager types as meta data.">MetaDataList</a> <a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a966292fbcb304e584f411075f95cf5b2" title="Stored separately to allow iteration.">mMetaDataList</a>;
<a name="l00102"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a6246f52d458fd225d38ac5341ea0385e">00102</a>         <a class="code" href="classOgre_1_1DefaultSceneManagerFactory.html" title="Factory for default scene manager.">DefaultSceneManagerFactory</a> <a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a6246f52d458fd225d38ac5341ea0385e" title="Factory for default scene manager.">mDefaultFactory</a>;
<a name="l00104"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a7742ef989061d92dc8ad9a5c12dedc7e">00104</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a7742ef989061d92dc8ad9a5c12dedc7e" title="Count of creations for auto-naming.">mInstanceCreateCount</a>;
<a name="l00106"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a3cc008e5a1a0c9cdb40ea466edde6f34">00106</a>         <a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>* <a class="code" href="classOgre_1_1SceneManagerEnumerator.html#a3cc008e5a1a0c9cdb40ea466edde6f34" title="Currently assigned render system.">mCurrentRenderSystem</a>;
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109     <span class="keyword">public</span>:
<a name="l00110"></a>00110         <a class="code" href="classOgre_1_1SceneManagerEnumerator.html" title="Enumerates the SceneManager classes available to applications.">SceneManagerEnumerator</a>();
<a name="l00111"></a>00111         ~<a class="code" href="classOgre_1_1SceneManagerEnumerator.html" title="Enumerates the SceneManager classes available to applications.">SceneManagerEnumerator</a>();
<a name="l00112"></a>00112 
<a name="l00117"></a>00117         <span class="keywordtype">void</span> addFactory(<a class="code" href="classOgre_1_1SceneManagerFactory.html" title="Class which will create instances of a given SceneManager.">SceneManagerFactory</a>* fact);
<a name="l00118"></a>00118 
<a name="l00121"></a>00121         <span class="keywordtype">void</span> removeFactory(<a class="code" href="classOgre_1_1SceneManagerFactory.html" title="Class which will create instances of a given SceneManager.">SceneManagerFactory</a>* fact);
<a name="l00122"></a>00122 
<a name="l00132"></a>00132         <span class="keyword">const</span> <a class="code" href="structOgre_1_1SceneManagerMetaData.html" title="Structure containing information about a scene manager.">SceneManagerMetaData</a>* getMetaData(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; typeName) <span class="keyword">const</span>;
<a name="l00133"></a>00133 
<a name="l00134"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#aba1ede3f8195a234c286f372ef181ce0">00134</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">ConstVectorIterator&lt;MetaDataList&gt;</a> <a class="code" href="classOgre_1_1SceneManagerEnumerator.html#aba1ede3f8195a234c286f372ef181ce0">MetaDataIterator</a>;
<a name="l00138"></a>00138         <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">MetaDataIterator</a> getMetaDataIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00139"></a>00139 
<a name="l00151"></a>00151         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* createSceneManager(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; typeName, 
<a name="l00152"></a>00152             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00153"></a>00153 
<a name="l00166"></a>00166         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* createSceneManager(<a class="code" href="group__Scene.html#gaa4b6dbd7bf722582a21fcc25d25f73ed" title="Bitmask containing scene types.">SceneTypeMask</a> typeMask, 
<a name="l00167"></a>00167             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00168"></a>00168 
<a name="l00170"></a>00170         <span class="keywordtype">void</span> destroySceneManager(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* sm);
<a name="l00171"></a>00171 
<a name="l00176"></a>00176         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* getSceneManager(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName) <span class="keyword">const</span>;
<a name="l00177"></a>00177 
<a name="l00181"></a>00181         <span class="keywordtype">bool</span> hasSceneManager(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName) <span class="keyword">const</span>;
<a name="l00182"></a>00182 
<a name="l00183"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#ad27d358bd89b7b44a8b360ce36df3aaa">00183</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">MapIterator&lt;Instances&gt;</a> <a class="code" href="classOgre_1_1SceneManagerEnumerator.html#ad27d358bd89b7b44a8b360ce36df3aaa">SceneManagerIterator</a>;
<a name="l00185"></a>00185         <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">SceneManagerIterator</a> getSceneManagerIterator(<span class="keywordtype">void</span>);
<a name="l00186"></a>00186 
<a name="l00189"></a>00189         <span class="keywordtype">void</span> setRenderSystem(<a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>* rs);
<a name="l00190"></a>00190 
<a name="l00192"></a>00192         <span class="keywordtype">void</span> shutdownAll(<span class="keywordtype">void</span>);
<a name="l00208"></a>00208         <span class="keyword">static</span> <a class="code" href="classOgre_1_1SceneManagerEnumerator.html" title="Enumerates the SceneManager classes available to applications.">SceneManagerEnumerator</a>&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l00224"></a>00224         <span class="keyword">static</span> <a class="code" href="classOgre_1_1SceneManagerEnumerator.html" title="Enumerates the SceneManager classes available to applications.">SceneManagerEnumerator</a>* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l00225"></a>00225 
<a name="l00226"></a>00226     };
<a name="l00227"></a>00227 
<a name="l00231"></a>00231 }
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
